## macaulay2 1.25.11+ds

=== M2/BUILD/rpm/Makefile ===
always:
	@cat README.md

DISTRIBUTION = almalinux
RELEASE = latest
VERSION := $(shell cat ../../VERSION)
TARNAME = Macaulay2-$(VERSION)

ifeq ($(DISTRIBUTION), fedora)
	DOCKERDIR = fedora
else
	DOCKERDIR = rhel
endif

HOST_RPMBUILD = rpmbuild-$(DISTRIBUTION)-$(RELEASE)
CTR_RPMBUILD = /home/macaulay/rpmbuild

rpm: $(HOST_RPMBUILD) .image-built-$(DISTRIBUTION)-$(RELEASE)
	sudo chown -R 1000:0 $(HOST_RPMBUILD)
	docker run \
		--entrypoint bash                             \
		-v $(CURDIR)/$(HOST_RPMBUILD):$(CTR_RPMBUILD) \
		m2-$(DISTRIBUTION)-$(RELEASE)-build           \
		-c 'set -e; \
			rpmbuild -ba $(CTR_RPMBUILD)/SPECS/Macaulay2.spec'

$(HOST_RPMBUILD): Macaulay2.spec
	rm -rf $@
	mkdir -p $@/SPECS
	cp Macaulay2.spec $@/SPECS
	mkdir -p $@/SOURCES
# build tarball (essentially the same as "make dist")
	cd ../../.. && git archive --prefix=$(TARNAME)/ \
		-o $(CURDIR)/M2.tar HEAD
	git submodule update --init ../../Macaulay2/editors/emacs
	cd ../../Macaulay2/editors/emacs && \
		git archive \
			--prefix=$(TARNAME)/M2/Macaulay2/editors/emacs/ \
			-o $(CURDIR)/M2-emacs.tar HEAD
	tar --concatenate --file=M2.tar M2-emacs.tar
	gzip M2.tar
	mv M2.tar.gz $@/SOURCES/$(TARNAME).tar.gz
	rm *.tar

.image-built-%:
	$(MAKE) -C ../docker/$(DOCKERDIR) build-image \
		DISTRIBUTION=$(DISTRIBUTION) RELEASE=$(RELEASE)
	touch $@

clean:
	rm -rf .image-built-* rpmbuild-*

=== M2/Macaulay2/c/CMakeLists.txt ===
###############################################################################
# Safe C Compiler (SCC)
# In this directory we compile "scc1", the D to C translator, which we want to
# run on the "build" machine, in the sense of autoconf.

set(HEADERS scc.h grammar.h keywords.h
  scc1.h readfile.h error.h dictionary.h list.h cprint.h type.h chk.h compat.h debugging.h)
set(SOURCES
  scc1.c readfile.c error.c dictionary.c list.c cprint.c type.c chk.c compat.c debugging.c)

# Compile the grammar
find_package(BISON REQUIRED QUIET)
BISON_TARGET(scc-grammar
  ${CMAKE_CURRENT_SOURCE_DIR}/grammar.y
  ${CMAKE_CURRENT_BINARY_DIR}/grammar.c
  DEFINES_FILE ${CMAKE_CURRENT_BINARY_DIR}/grammar.h
  COMPILE_FLAGS -yvdlt)

# Generate TAGS file
if(ETAGS)
  set(TAGS TAGS)
  set_source_files_properties(TAGS PROPERTIES GENERATED true)
  add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/TAGS
    COMMENT "Generating c/TAGS file"
    COMMAND ${ETAGS} -o TAGS ${HEADERS} ${SOURCES} grammar.y scc-core.h scc-core.c
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
endif()

# Compile scc1
add_executable(scc1 ${HEADERS} ${SOURCES} grammar.c ${TAGS})

target_include_directories(scc1 PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
  $<INSTALL_INTERFACE:include/Macaulay2>)

if(BDWGC_FOUND AND GDBM_FOUND)
  target_link_libraries(scc1 Threads::Threads
    ${BDWGC_LIBRARIES} ${GDBM_LIBRARY} ${CMAKE_DL_LIBS})
  target_include_directories(scc1 PUBLIC
    $<BUILD_INTERFACE:${BDWGC_INCLUDE_DIR}>
    $<BUILD_INTERFACE:${GDBM_INCLUDE_DIR}>)
endif()

target_compile_options(scc1 PRIVATE
  $<$<COMPILE_LANG_AND_ID:C,GNU>:-Wno-implicit-fallthrough>) # FIXME: caused by type.c:175:26

=== M2/Macaulay2/d/CMakeLists.txt ===
###############################################################################
## This directory contains the rules for building M2-interpreter

include(scc) ## CMake macro for calling the Safe C Compiler

# TODO: changing this causes a lot of recompiling
## Configure distributed-packages.h at the destination
string(REPLACE ";" " " DISTRIBUTED_PACKAGES "${DISTRIBUTED_PACKAGES}")
# TODO: configure this header directly in version.dd?
file(GENERATE OUTPUT distributed-packages.h CONTENT "#define DISTRIBUTED_PACKAGES \"${DISTRIBUTED_PACKAGES}\"")

## Configure version.dd at the destination
#configure_file(version.dd.in version.dd #ONLY)

###############################################################################

set(CLIST
  M2types.c M2lib.c M2mem.c types.h
  scclib.c ../c/scc-core.h
  memdebug.c memdebug.h
  debug.c debug.h
  getpagesize.h M2mem.h
  gmp_aux.c gmp_aux.h
  gdbm_interface.c
  )

set(CXXLIST boost-regex.cpp)

# CAUTION: order is important in this list
# TODO: can there be #ifdefs in D sources?
set(DLIST
  arithmetic.d
  atomic.d
  M2.d
  system.d
  strings.d
  varstrin.d
  strings1.d
  vararray.d
  ctype.d
  nets.d
  varnets.d
  interrupts.d
  pthread0.d
  stdiop0.d
  gmp.d
  ballarith.d
  engine.dd
  xml.d		# removed unless WITH_XML
  stdio0.d
  errio.d
  parse.d
  expr.d
  stdio.d
  stdiop.d
  err.d
  gmp1.d
  tokens.d
  getline.d
  lex.d
  parser.d
  binding.d
  basic.d
  common.d
  util.d
  convertr.d
  struct.d
  classes.dd
  buckets.dd
  equality.dd
  hashtables.dd
  regex.dd
  debugging.dd
  evaluate.d
  sets.dd
  mysql.d	# removed unless WITH_SQL
  mysqldummy.d	# removed if WITH_SQL
  pthread.d
  actors.d
  actors2.dd
  actors3.d
  actors4.d
  # tasks.d
  xmlactors.d	# removed unless WITH_XML
  actors5.d
  chrono.dd
  profiler.dd
  threads.dd
  python.d	# removed unless WITH_PYTHON
  interface.dd interface2.d
  monoid.dd
  monomial_ordering.dd
  texmacs.d
  boostmath.dd
  atomic2.d
  ffi.d		# removed unless WITH_FFI
  interp.dd	# this one is last, because it contains the top level interpreter
  version.dd
  )

# Generator expressions conflict with the macro below, so manually remove the ones we don't need
if(NOT WITH_XML)
  list(REMOVE_ITEM DLIST xml.d xmlactors.d)
endif()
if(NOT WITH_SQL)
  list(REMOVE_ITEM DLIST mysql.d)
else()
  list(REMOVE_ITEM DLIST mysqldummy.d)
endif()
if(NOT WITH_PYTHON)
  list(REMOVE_ITEM DLIST python.d)
endif()
if(NOT WITH_FFI)
  list(REMOVE_ITEM DLIST ffi.d)
endif()

###############################################################################
## Generate TAGS file
# TODO: the order is somewhat different, is it a problem?

if(ETAGS)
  set(TAGS TAGS)
  set_source_files_properties(TAGS PROPERTIES GENERATED true)
  add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/TAGS
    COMMENT "Generating d/TAGS file"
    COMMAND ${ETAGS} -o TAGS ${CLIST} ${CXXLIST} ${DLIST}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
endif()

###############################################################################
## Generate the interpreter

foreach(_d_source IN LISTS DLIST)
  # See cmake/scc.cmake
  _SCC_TRANSLATE(${_d_source} _c) # sets _c_source
  list(APPEND CLIST ${_c_source})
endforeach()

###############################################################################
## Compile the interpreter

# TODO: gmp.d, basic.d, and equality.d require elements from M2-engine
# for that reason, interpreter cannot be compiled as a static library, yet
add_library(M2-interpreter OBJECT ${CLIST} ${CXXLIST} ${TAGS}
  distributed-packages.h
  $<$<BOOL:${WITH_XML}>:xml-c.c xml-c.h>
  $<$<BOOL:${WITH_PYTHON}>:python-c.c>)

target_link_libraries(M2-interpreter PRIVATE M2-supervisor
  Boost::boost # boost_regex is now header-only, so we don't link Boost::regex
  $<$<BOOL:${WITH_TBB}>:TBB::tbb>
  $<$<BOOL:${WITH_FFI}>:FFI::ffi>)

# TODO: c.f. https://github.com/Macaulay2/M2/issues/2682
if(NOT APPLE)
  target_link_libraries(M2-interpreter PRIVATE quadmath)
endif()

target_include_directories(M2-interpreter
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/Macaulay2/e> # need newdelete.hpp
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/Macaulay2/c> # need scc-core.h
    $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}/Macaulay2/d>
    # for version.dd to get version numbers
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/Macaulay2/e/mathic>
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/Macaulay2/e/memtailor>
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/Macaulay2/e/mathicgb>
    # for libraries that the interpreter needs
    $<BUILD_INTERFACE:${READLINE_INCLUDE_DIR}>
    $<BUILD_INTERFACE:${LIBXML2_INCLUDE_DIR}>
    $<BUILD_INTERFACE:${EIGEN3_INCLUDE_DIR}>
    $<INSTALL_INTERFACE:include/Macaulay2>
    $<$<BOOL:${WITH_PYTHON}>:$<BUILD_INTERFACE:${Python3_INCLUDE_DIRS}>>
  PRIVATE
    # Note: this shouldn't be necessary since FFI::ffi is linked above
    $<$<BOOL:${WITH_FFI}>:$<BUILD_INTERFACE:${FFI_INCLUDE_DIRS}>>
    ${SQLite3_INCLUDE_DIRS}
  )

# TODO: Including most of these is only necessary because of version.dd
# changing or moving that file would allow moving this to e/CMakeLists.txt
foreach(LIB IN LISTS PKGLIB_LIST)
  if(${LIB}_FOUND)
    target_link_libraries(M2-interpreter PUBLIC PkgConfig::${LIB})
  endif()
endforeach()

foreach(LIB IN LISTS LIBRARIES_LIST)
  if(${LIB}_FOUND)
    target_link_libraries(M2-interpreter PUBLIC ${${LIB}_LIBRARIES})
    target_include_directories(M2-interpreter PUBLIC
        "$<BUILD_INTERFACE:${${LIB}_INCLUDE_DIR}>")
  endif()
endforeach()

foreach(LIB IN LISTS LIBRARY_LIST)
  if(${LIB}_FOUND)
    target_link_libraries(M2-interpreter PUBLIC ${${LIB}_LIBRARY})
    target_include_directories(M2-interpreter PUBLIC
        "$<BUILD_INTERFACE:${${LIB}_INCLUDE_DIR}>")
  endif()
endforeach()

# Compiler warning flags
target_compile_options(M2-interpreter PRIVATE
  -Wno-cast-qual # FIXME: caused by M2lib.c:551:43
  -Wno-sign-compare
  -Wno-uninitialized
  -Wno-unused
  -Wno-array-bounds   # FIXME: caused by scc1's implementation of arrays

  # FIXME: mismatched-tags and parentheses-equality errors are caused by scc1
  $<$<COMPILE_LANG_AND_ID:C,AppleClang,Clang>:-Wno-parentheses-equality>
  $<$<COMPILE_LANG_AND_ID:CXX,AppleClang,Clang>:-Wno-mismatched-tags -Wno-parentheses-equality>
  # FIXME: caused by SIMD macro redefinition in fflas_ffpack
  $<$<COMPILE_LANG_AND_ID:CXX,AppleClang,Clang>:-Wno-macro-redefined>

  # FIXME: __builtin_frame_address M2lib.c:165 causes this:
  $<$<COMPILE_LANG_AND_ID:C,GNU>:-Wno-frame-address>
  # Givaro and fflas_ffpack cause these:
  $<$<COMPILE_LANG_AND_ID:CXX,GNU>:-Wno-deprecated-copy -Wno-unknown-pragmas>
  )
# add other compilers (eg: Intel, MSVC) here
# for Intel: -diag-disable 981,869,383,2259,444 -debug

###############################################################################
## Export the target

install(TARGETS M2-interpreter EXPORT Macaulay2 COMPONENT devel EXCLUDE_FROM_ALL)

=== M2/Macaulay2/editors/CMakeLists.txt ===
###############################################################################
## This directory contains the rules for generating grammar files for editors
## and syntax highlighting engines as well as the M2-mode package for Emacs.
## - M2-editors generates grammar files
## - M2-emacs   generates the M2-mode package for Emacs

# TODO: generate vim grammar
# TODO: generate textmate grammar

set(M2 ${M2_DIST_PREFIX}/${M2_INSTALL_BINDIR}/M2)
set(M2_ARGS --script)

###############################################################################
## Generating the grammar files is mainly done in make-M2-symbols.m2.
## To add to the M2-editors target, add grammar filenames here and in .gitignore.
set(GRAMMAR_FILES
  prism/macaulay2.js
  pygments/macaulay2.py
#  rouge/macaulay2.rb
  vim/m2.vim.syntax
  vim/m2.vim.dict
  emacs/M2-symbols.el)

set(GRAMMAR_TEMPLATES ${GRAMMAR_FILES})
list(TRANSFORM GRAMMAR_TEMPLATES APPEND ".in")
add_custom_target(M2-editors DEPENDS ${GRAMMAR_FILES})
add_custom_command(OUTPUT ${GRAMMAR_FILES}
  COMMENT "Generating M2 grammar files for editors"
  COMMAND ${M2} ${M2_ARGS} ${CMAKE_CURRENT_SOURCE_DIR}/make-M2-symbols.m2
  MAIN_DEPENDENCY make-M2-symbols.m2
  DEPENDS M2-core ${GRAMMAR_TEMPLATES})

###############################################################################
## Generating the M2-mode package for Emacs

if(NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/emacs/make-M2-emacs-help.m2)
  message(WARNING "Macaulay2/editors/emacs submodule is missing; skipping M2-emacs target")
  return()
endif()

# TODO: only the emacs target is installed in usr-dist by default
set(M2_INSTALL_EMACSDIR
  ${M2_DIST_PREFIX}/${M2_INSTALL_DATAROOTDIR}/emacs/site-lisp/macaulay2)
file(COPY emacs/ DESTINATION ${M2_INSTALL_EMACSDIR}
  FILES_MATCHING PATTERN "M2*" PATTERN "*.in" EXCLUDE)

set(EMACS_FILES M2-emacs-help.txt M2-emacs.m2 M2-symbols.el.gz)
list(TRANSFORM EMACS_FILES PREPEND ${M2_INSTALL_EMACSDIR}/)
add_custom_target(M2-emacs ALL DEPENDS ${EMACS_FILES})
add_custom_command(OUTPUT ${EMACS_FILES}
  COMMENT "Generating Emacs package"
  COMMAND ${M2} ${M2_ARGS} ${CMAKE_CURRENT_SOURCE_DIR}/emacs/make-M2-emacs-help.m2
  COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_BINARY_DIR}/emacs/M2-symbols.el ${M2_INSTALL_EMACSDIR}
  COMMAND gzip -nf9 M2-symbols.el
  # This command updates the generated content in the M2-emacs submodule
  COMMAND ${CMAKE_COMMAND} -E copy M2-emacs-help.txt M2-emacs.m2 M2-symbols.el.gz ${CMAKE_CURRENT_SOURCE_DIR}/emacs
  MAIN_DEPENDENCY emacs/make-M2-emacs-help.m2
  WORKING_DIRECTORY ${M2_INSTALL_EMACSDIR}
  DEPENDS emacs/M2-symbols.el make-M2-symbols.m2)

################################################################################
## Generating prism.js/highlight.js for syntax highlighting in the html
## documentation

set(PRISM_DIR ${CMAKE_CURRENT_BINARY_DIR}/prism)
file(MAKE_DIRECTORY PRISM_DIR)
file(COPY prism/ DESTINATION ${PRISM_DIR}
  FILES_MATCHING PATTERN "*.json" PATTERN "*.js" PATTERN "*.css")

if(NOT NPM)
  return()
endif()

add_custom_target(M2-prism ALL DEPENDS prism/prism.js)
add_custom_command(OUTPUT prism/prism.js
  COMMENT "Generating prism.js syntax file"
  COMMAND ${NPM} install && ${NPM} run build
  WORKING_DIRECTORY ${PRISM_DIR}
  DEPENDS prism/macaulay2.js)

=== M2/Macaulay2/m2/CMakeLists.txt ===
###############################################################################
## This directory contains the rules for building M2-core

set(CORE_DIR ${M2_DIST_PREFIX}/${M2_INSTALL_DATADIR}/Core)
set(CORE_TESTS ${CORE_DIR}/tests)
set(M2_ARGS -q --silent --stop -e errorDepth=0 --no-preload)

# List of Core sources
file(STRINGS loadsequence M2LIST)

###############################################################################
## Generate TAGS file
# TODO: the TAGS file generated by Makefile has way more sources

if(ETAGS)
  set(TAGS ${CMAKE_CURRENT_SOURCE_DIR}/TAGS)
  set_source_files_properties(TAGS PROPERTIES GENERATED true)
  add_custom_command(OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/TAGS
    COMMENT "Generating m2/TAGS file"
    COMMAND ${ETAGS} -o TAGS startup.m2.in Core.m2 ${M2LIST} ${CORE_DIR}/tvalues.m2
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    DEPENDS ${CORE_DIR}/tvalues.m2)
endif()

###############################################################################
## Generate startup.m2, version.m2, and tvalues.m2 and copy the core to usr-dist

## Configure startup.m2
configure_file(startup.m2.in startup.m2 @ONLY)

add_custom_target(M2-core ALL DEPENDS ${CORE_DIR}/tvalues.m2 ${TAGS})

add_custom_command(OUTPUT ${CORE_DIR}/tvalues.m2
  COMMENT "Generating Macaulay2/Core/tvalues.m2"
  COMMAND rm -f ${CORE_DIR}/tvalues.m2     # delete old tvalues.m2
  COMMAND M2-binary ${M2_ARGS} -e "exit 0" # regenerate tvalues.m2
  WORKING_DIRECTORY ${CORE_DIR}
  DEPENDS M2-binary
  VERBATIM)

## Populate GIT_DESCRIPTION and GIT_BRANCH
configure_file(version.m2.in ${M2_DIST_PREFIX}/${M2_INSTALL_DATADIR}/Core/version.m2 @ONLY)

foreach(filename IN LISTS M2LIST ITEMS
    ${CMAKE_CURRENT_BINARY_DIR}/startup.m2 Core.m2 exports.m2 loadsequence)
  file(COPY ${filename} DESTINATION ${CORE_DIR})
endforeach()

## Copy Core tests from Macaulay2/tests/normal to share/doc/Macaulay2/Core/tests
file(COPY ${CMAKE_SOURCE_DIR}/Macaulay2/tests/normal/ DESTINATION ${CORE_TESTS}
  FILES_MATCHING PATTERN "*.m2")

# TODO: handle Style here.

=== M2/Macaulay2/tests/CMakeLists.txt ===
###############################################################################
## This directory contains the rules for adding various tests to CTest.
##
## - list tests:      ctest -N
## - build and test:  ctest --build-and-test
## - rerun matching tests:
##     ctest -R schorder --rerun-failed -V
##
## See https://gitlab.kitware.com/cmake/community/-/wikis/doc/ctest/Testing-With-CTest

# TODO: some targets have different resource limits
set(SUBDIRS normal slow gigantic goals quarantine engine threads)

add_custom_target(M2-tests)
add_dependencies(M2-tests M2-tests-ComputationsBook) # M2-tests-rationality

###############################################################################
## Default resource limits
# TODO: add memory, virtual memory, and stack size
# the tests aren't run through bash, so ulimit wouldn't work
if(DEBUG)
  set(CTEST_TEST_TIMEOUT 1400)
  #MLIMIT ?= 1200000
  #VLIMIT ?= 2000000
else()
  set(CTEST_TEST_TIMEOUT 900)
  ## one test doesn't work with only 150MB RAM, ext-total.m2, on a 64 bit intel machine:
  #MLIMIT ?=  800000
  #VLIMIT ?= 2000000
endif()
## make the stack limit always the same as it would be under MacOS
#SLIMIT ?= 8192

###############################################################################
## M2 arguments and commands that will be passed to M2 -e ${STR}
set(GC_MAXIMUM_HEAP_SIZE 400M CACHE STRING "maximum collected heap size")
set(M2 ${M2_DIST_PREFIX}/${M2_INSTALL_BINDIR}/M2)
# gbTrace, errorDepth, and debugLevel are set in packages/CMakeLists.txt
set(M2_ARGS
  -q --stop --silent --no-debug --no-randomize # --no-prompts --no-...
  -e errorDepth=${errorDepth} -e debugLevel=${debugLevel} -e gbTrace=${gbTrace})
set(M2_PATH "join(path,{\"${CMAKE_CURRENT_SOURCE_DIR}/\",\"${CMAKE_SOURCE_DIR}/packages/\"})")
# Read the file, then exit. Note: a "restart" command causes the test to not halt
set(M2_TEST_TEMPLATE [[input("@CMAKE_CURRENT_SOURCE_DIR@/@_group@/@_testfile@")]])

# Allow GC_MAXIMUM_HEAP_SIZE to be set via environment variable
foreach(_var in ITEMS GC_MAXIMUM_HEAP_SIZE)
  if(DEFINED ENV{${_var}})
    message("## Set via environment:   ${_var}\t= $ENV{${_var$}} (default: ${${_var}})")
    set(${_var} "$ENV{${_var}}")
  endif()
endforeach()

## Regular expressions for various test errors
## TODO: add WILL_FAIL tests
set(M2_FAIL_REGEX
  [[internal error;non-zero status;assertion failed]]
  "--back trace--"
  "\nCommand terminated;\nGC;\n0x;\nout of mem"
  "user.*system.*elapsed;\n[0-9]+\.[0-9]+user"
  [[\.m2:[0-9][0-9]*:[0-9][0-9]*:\([0-9][0-9]*\):]] # TODO: this one catches commented errors
  )

###############################################################################
## Adding tests for all subdirectories

foreach(_group IN LISTS SUBDIRS)

  ## eg: LU.m2 ...
  file(GLOB ${_group}_TESTS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/${_group} "${_group}/*.m2")

  foreach(_testfile IN LISTS ${_group}_TESTS)
    ## ctest target for testing the package
    set(_testname ${_group}/${_testfile})

    ## configure the test string
    string(CONFIGURE "${M2_TEST_TEMPLATE}" M2_TEST_STRING)

    add_test(NAME ${_testname}
      COMMAND ${M2} ${M2_ARGS} -e path=${M2_PATH} -e ${M2_TEST_STRING} -e "exit 0"
      WORKING_DIRECTORY	${CMAKE_CURRENT_SOURCE_DIR}/${_group}
      )

    set_tests_properties(${_testname} PROPERTIES
      FAIL_REGULAR_EXPRESSION "${M2_FAIL_REGEX}"
      ENVIRONMENT "GC_MAXIMUM_HEAP_SIZE=${GC_MAXIMUM_HEAP_SIZE}"
      TIMEOUT ${CTEST_TEST_TIMEOUT} # TODO: this shouldn't be necessary
      )
  endforeach()

endforeach()

###############################################################################
## ComputationsBook targets:
# - M2-tests-ComputationsBook-${_chapter}
# - M2-tests-ComputationsBook-${_chapter}-changes
# - M2-tests-ComputationsBook-${_chapter}-diff
# Tests:
# - ComputationsBook/${_chapter}

add_custom_target(M2-tests-ComputationsBook)

set(CHAPTERS completeIntersections constructions d-modules exterior-algebra geometry
  monomialIdeals preface programming schemes solving toricHilbertScheme varieties)

set(M2_ARGS -q --stop --print-width 0 --silent)

foreach(_chapter IN LISTS CHAPTERS)

  ## configure the test string
  set(_testfile test.m2)
  set(_group ComputationsBook/${_chapter})

  set(book_patterns    ${CMAKE_CURRENT_SOURCE_DIR}/${_group}/../patterns)
  set(chapter_patterns ${CMAKE_CURRENT_SOURCE_DIR}/${_group}/patterns)

  string(CONFIGURE "${M2_TEST_TEMPLATE}" M2_TEST_STRING)
  set(M2_PATH "join({\"${CMAKE_CURRENT_BINARY_DIR}/${_group}\",\"${CMAKE_CURRENT_SOURCE_DIR}/${_group}\"},path)")

  if(NOT EXISTS ${CMAKE_CURRENT_BINARY_DIR}/${_group})
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${_group})
  endif()

  ###############################################################################
  # we depend on "diff" accepting some options that perhaps only GNU diff does
  add_custom_target(M2-tests-ComputationsBook-${_chapter}
    COMMAND ${M2} ${M2_ARGS} -e path=${M2_PATH} -e ${M2_TEST_STRING} -e "exit 0" > test.out 2>&1
    COMMAND sed -f ${book_patterns} -f ${chapter_patterns} > test.out.trim < test.out
    COMMAND sed -f ${book_patterns} -f ${chapter_patterns} > test.out.expected.trim
      < ${CMAKE_CURRENT_SOURCE_DIR}/${_group}/test.out.expected
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${_group}
    VERBATIM
    )
  add_custom_target(M2-tests-ComputationsBook-${_chapter}-diff
    COMMAND diff -B -b -u test.out.expected.trim test.out.trim
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${_group}
    DEPENDS M2-tests-ComputationsBook-${_chapter}
    VERBATIM
    )
  add_custom_target(M2-tests-ComputationsBook-${_chapter}-changes
    COMMAND diff -u chapter.m2 test.m2 || true
    COMMAND diff -u chapter.out.expected test.out.expected || true
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/${_group}
    VERBATIM
    )

  add_dependencies(M2-tests-ComputationsBook M2-tests-ComputationsBook-${_chapter})

  ###############################################################################
  add_test(NAME ${_group}
    COMMAND diff -B -b -u
      ${CMAKE_CURRENT_BINARY_DIR}/${_group}/test.out.expected.trim
      ${CMAKE_CURRENT_BINARY_DIR}/${_group}/test.out.trim
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/${_group}
    )

  # TODO: capture output from the chapter's code with M2 version 0.9.2 as a standard of comparison.
  # this requires an old binary, but we run it only once and save the output
  #set(OLDM2 M2-0.9.2)
  #set(OLDM2CMD ${LIMIT} time nice -18 ${OLDM2} -s -q -e${PATHJOIN})
  #add_custom_command(OUTPUT test.oldout test.oldvalues
  #  COMMAND ${OLDM2CMD} -e'load "$(chapter_srcdir)/../capture.m2"; input "$<"; exit 0'  >test.oldout.tmp </dev/null
  #  COMMAND mv test.oldout.tmp test.oldout
  #  DEPENDS chapter.m2 ../capture.m2
  #  )
  #add_custom_target(ComputationsBook-capture
  #  DEPENDS test.oldout test.oldvalues
  #  )

endforeach()

# TODO: add_subdirectory(rationality)

=== M2/BUILD/docker/autotools/Makefile ===
# include this Makefile in other docker Makefiles to add a
# 'build-autotools' target for running the entire autotools build

define M2_BUILD_SCRIPT_autotools
set -xe

git config --global --add safe.directory $(M2_HOME)/M2
mkdir -p M2/$(BUILD_DIR)
cd M2/$(BUILD_DIR)
$(M2_HOME)/M2/M2/autogen.sh
$(M2_HOME)/M2/M2/configure $(CONFIG_OPT)
make $(MAKE_OPT)
endef
export M2_BUILD_SCRIPT_autotools

build-autotools: build-image
	docker run $(VOLUME) -it --entrypoint="" $(TAG) \
		bash -c "$$M2_BUILD_SCRIPT_autotools"

=== M2/BUILD/docker/nightly/Makefile ===
include ../Makefile

## Parameters
TAG = m2-github-nightly
BUILD_DIR = ..

###############################################################################
# see ../Makefile

=== M2/BUILD/docker/rhel/Makefile ===
include ../Makefile
include ../autotools/Makefile

## Parameters
DISTRIBUTION = almalinux
RELEASE = latest
BUILD_ARGS = --build-arg DISTRIBUTION=$(DISTRIBUTION) \
	--build-arg RELEASE=$(RELEASE)
TAG = m2-$(DISTRIBUTION)-$(RELEASE)-build
BUILD_DIR = M2/BUILD/build-docker

CONFIG_OPT = --with-system-gc --enable-download --enable-rpm --prefix=/usr

=== debian/changelog ===
macaulay2 (1.25.11+ds-4) unstable; urgency=medium

  * Rebuild against normaliz 3.11.1 to hopefully fix segfaults in CI tests
    again.
  * Rename the Emacs package installed by elpa-macaulay2 from "macaulay2"
    to "M2" to match the actual upstream package name.
  * debian/elpa-macaulay2.elpa
    - Update the name of the installed -pkg.el file.
  * debian/M2-pkg.el.in
    - Rename from d/macaulay2-pkg.el.in.
    - Update the package description slightly.
  * debian/rules
    - Export ELPA_NAME with new package name.
    - Update generation of -pkg.el file with new name.
  * debian/scripts/m2-get-orig-source.sh
    - Simplify slightly by using the $TARBALL variable throughout.

 -- Doug Torrance <dtorrance@debian.org>  Sat, 07 Feb 2026 17:21:54 -0500

macaulay2 (1.25.11+ds-3) unstable; urgency=medium

  * debian/control
    - Drop Priority field; "optional" is now the default.
    - Bump Standards-Version to 4.7.3.
  * debian/copyright
    - Update my copyright years.
  * debian/source/options
    - Remove Python examples from ignored files; they no longer exist.
  * debian/tests/check-packages.m2
    - New file; just check packages that interface w/ other software.
      Running the entire package test suite takes ~1h, which is discouraged
      by best practices and has led to many issues.  For example, normaliz
      is not transitioning from resolute-proposed in Ubuntu right now
      because the macaulay2 autopkgtests are timing out.
  * debian/tests/control
    - Drop Architecture field for package-tests.  The only reason we were
      only testing on amd64 and arm64 was because of the timeout issues
      mentioned above.

 -- Doug Torrance <dtorrance@debian.org>  Mon, 19 Jan 2026 10:01:18 -0500

macaulay2 (1.25.11+ds-2) unstable; urgency=medium

  * Rebuild against normaliz 3.11.0.  Should fix segfaults when running
    tests with M2 built against normaliz 3.10.5 but normaliz 3.11.0 is
    installed.
  * debian/macaulay2-common.lintian-overrides
    - Update package-contains-documentation-outside-usr-share-doc
      overrides (one new file and one file with an updated path).
  * debian/patches/gitignore.patch
    - New patch; don't install .gitignore files in package directories.
      Fixes package-contains-vcs-control-file Lintian warning.
  * debian/patches/privacy-breach-generic.patch
    - New patch; don't use external website for IFRAME example. Fixes
      privacy-breach-generic Lintian warning.

 -- Doug Torrance <dtorrance@debian.org>  Sun, 14 Dec 2025 09:09:53 -0500

macaulay2 (1.25.11+ds-1) unstable; urgency=medium

  * New upstream release.
  * debian/control
    - Drop versioned dependencies on libflint-dev and libjs-query, newer
      versions are now in oldoldstable.
    - Switch libjs-bootstrap -> libjs-bootstrap5 (Closes: #1088424).
    - Switch fonts-glyphicons-halflings -> node-fortawesome-fontawesome-free.
  * debian/copyright
    - Update Files-Excluded.  We now remove the entire js directory for
      the Visualize package, as all of its files are now automatically
      generated by webpack.
    - Update the copyright information for some of my upstream packages
      (now GPL).
    - Add copyright information for new packages:
      + CpMackeyFunctors
      + ExteriorExtensions
      + LieAlgebraRepresentations (formerly LieTypes)
      + MatrixFactorization
      + NonPrincipalTestIdeals
      + PathSignatures
      + Tableaux
      + WeilDivisors (formerly Divisors)
    - Update filename for JSON package test.
    - Drop stanza for removed pkg.m4.
  * debian/macaulay2-common.linktress
    - Update symlinks for JavaScript libraries (bootstrap3 -> bootstrap5
      and using fontawesome instead of glyphicons).
  * debian/patches
    - Remove patches applied upstream:
      + c++17.patch
      + normaliz.patch
      + package-files.patch
  * debian/patches/skip-failing-package-tests.patch
    - Skip new tests:
      + check(1, "Cyclotomic") (failing on all architectures)
      + check({72, 74, 75}, "EngineTests") (failing on s390x)
      + check(3, "NumericalImplicitiazation") (failing on s390x)
      + check(7, "Msolve") (failing on 32-bit systems)
      + check(8, "SpecialFanoFourfolds") (failing on armhf)
  * debian/patches/visualize.patch
    - New patch; use Debian packages instead of webpack-bundled JavaScript
      in the Visualize package.
  * debian/rules
    - Pass --disable-download to configure since --enable-download is now
      the default.
    - Drop get-orig-source target; we can use uscan directly now.
  * debian/watch
    - Update with new download location; upstream hosts tarballs on their
      website again.

 -- Doug Torrance <dtorrance@debian.org>  Fri, 14 Nov 2025 11:08:07 -0500

=== debian/control ===
Source: macaulay2
Section: math
Maintainer: Debian Math Team <team+math@tracker.debian.org>
Uploaders: Doug Torrance <dtorrance@debian.org>
Build-Depends: 4ti2,
               bison,
               cohomcalg,
               coinor-csdp,
               debhelper-compat (= 13),
               dh-linktree,
               emacs-nox,
               fflas-ffpack,
               flex,
               gfan,
               gfortran,
               install-info,
               libboost-dev,
               libboost-math-dev,
               libboost-regex-dev,
               libboost-stacktrace-dev,
               libcdd-dev,
               libeigen3-dev,
               libffi-dev,
               libflint-dev,
               libfrobby-dev,
               libfplll-dev,
               libgc-dev,
               libgdbm-dev,
               libglpk-dev,
               libgtest-dev,
               liblapack-dev,
               liblzma-dev,
               libmathic-dev,
               libmathicgb-dev (>= 1.0~git20220225~),
               libmemtailor-dev,
               libmpfi-dev,
               libmpfr-dev,
               libmps-dev,
               libnauty-dev,
               libnormaliz-dev,
               libntl-dev,
               libreadline-dev,
               libsingular4-dev (>= 1:4.2.0~),
               libtbb-dev,
               libxml2-dev,
               lrslib,
               lsb-release,
               msolve,
               nauty,
               normaliz,
               pkgconf,
               python3-dev <!nopython>,
               r-base,
               singular-data,
               time,
               topcom
Build-Depends-Indep: dh-sequence-elpa,
                     faketime,
                     fonts-katex,
                     gdbmtool,
                     jdupes,
                     libjs-bootsidemenu,
                     libjs-bootstrap5,
                     libjs-d3,
                     libjs-jquery,
                     libjs-katex (>= 0.11.0~),
                     libjs-nouislider,
                     libjs-three,
                     node-clipboard,
                     node-css-loader <!nodoc>,
                     node-fortawesome-fontawesome-free,
                     node-import-local <!nodoc>,
                     node-interpret <!nodoc>,
                     node-prismjs <!nodoc>,
                     node-prismjs-bibtex <!nodoc>,
                     node-rechoir <!nodoc>,
                     node-style-loader <!nodoc>,
                     npm <!nodoc>,
                     pkg-js-tools <!nodoc>,
                     webpack <!nodoc>
Standards-Version: 4.7.3
Homepage: http://macaulay2.com
Vcs-Browser: https://salsa.debian.org/math-team/macaulay2
Vcs-Git: https://salsa.debian.org/math-team/macaulay2.git
Rules-Requires-Root: no

Package: macaulay2
Architecture: any
Depends: gdbmtool,
         macaulay2-common (= ${source:Version}),
         normaliz,
         singular-data,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: 4ti2,
            cohomcalg,
            coinor-csdp,
            elpa-macaulay2 (= ${source:Version}),
            msolve,
            gfan,
            info,
            lrslib,
            nauty,
            texlive-latex-base,
            topcom,
            www-browser,
            xdg-utils,
            xterm
Suggests: bergman,
          dot2tex,
          fig2dev,
          graphviz,
          pdf-viewer,
          phcpack,
          polymake,
          r-base,
          qepcad,
          sdpa
Description: Software system for algebraic geometry research
 Macaulay 2 is a software system for algebraic geometry research, written by
 Daniel R. Grayson and Michael E. Stillman.  Based on Groebner bases, it
 provides algorithms for computing homological invariants of rings and
 modules.
 .
 This package contains the architecture dependent portion of Macaulay2.

Package: macaulay2-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Software system for algebraic geometry research (common files)
 Macaulay 2 is a software system for algebraic geometry research, written by
 Daniel R. Grayson and Michael E. Stillman.  Based on Groebner bases, it
 provides algorithms for computing homological invariants of rings and
 modules.
 .
 This package contains the architecture independent portion of Macaulay2, and is
 normally installed automatically when one of the architecture dependent
 packages is installed.

Package: elpa-macaulay2
Architecture: all
Multi-Arch: foreign
Section: editors
Depends: ${elpa:Depends}, ${misc:Depends}
Recommends: emacs
Description: Software system for algebraic geometry research (Emacs package)
 Macaulay 2 is a software system for algebraic geometry research, written by
 Daniel R. Grayson and Michael E. Stillman.  Based on Groebner bases, it
 provides algorithms for computing homological invariants of rings and
 modules.
 .
 This package contains the modes for running Macaulay2 within Emacs and
 editing Macaulay2 code.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk # for SOURCE_DATE_EPOCH

export DEB_BUILD_MAINT_OPTIONS=hardening=+all optimize=-lto

ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
export VERBOSE=1
endif

# needed for reproducible-version.patch
export CURDIR

VERSION := $(shell cat M2/VERSION)

%:
	dh $@ --sourcedirectory=M2 --with linktree

# use exec_prefix instead of prefix in libdir, as that's what's needed
# to properly substitute paths in Layout#2
LIBDIR := \$${exec_prefix}/lib/$(DEB_HOST_MULTIARCH)

# set emacs lisp file installation directory so that the documentation
# matches where dh_elpa installs them
ELPA_VERSION := $(shell emacs --batch \
	--eval '(require (quote package))' \
	--eval '(princ (package-version-join (version-to-list "$(VERSION)")))' \
	2> /dev/null)
EMACSDIR := \
	\$${prefix}/share/emacs/site-lisp/elpa-src/macaulay2-$(ELPA_VERSION)
export ELPA_NAME = M2

WITH_PYTHON := $(if $(filter nopython, $(DEB_BUILD_PROFILES)), --without-python)

ifneq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
DISABLE_DOCUMENTATION = --disable-documentation
else
DISABLE_DOCUMENTATION := $(if $(shell dh_listpackages -i),,\
	--disable-documentation)
endif

override_dh_auto_configure:
	dh_auto_configure --                \
		--libdir=$(LIBDIR)          \
		--with-emacsdir=$(EMACSDIR) \
		--with-system-libs          \
		LIBS="$(LIBS)"              \
		$(WITH_PYTHON)              \
		$(DISABLE_DOCUMENTATION)    \
		--with-fplll                \
		--disable-download
ifeq ($(DISABLE_DOCUMENTATION),)
	dh_auto_configure --buildsystem=nodejs
	mv node_modules M2/Macaulay2/editors/prism
endif

# prevent html-check-links from failing to find KaTeX files before
# they get added by dh_linktree
KATEX_DIR := $(CURDIR)/M2/Macaulay2/packages/Style/katex
KATEX_FILES := $(patsubst %, $(KATEX_DIR)/%, \
	katex.min.css katex.min.js contrib/auto-render.min.js \
	contrib/copy-tex.min.js contrib/render-a11y-string.min.js)

$(KATEX_DIR):
	mkdir -p $@/contrib

$(KATEX_DIR)/%: $(KATEX_DIR)
	touch $@

# copy cached example output files (for examples known to fail on
# various architectures) to source directory
# see generateExamples in debian/scripts/Debian.m2
EXAMPLE_SRC := $(wildcard $(CURDIR)/debian/examples/*)
EXAMPLE_DEST := $(patsubst $(CURDIR)/debian/examples/%, \
	$(CURDIR)/M2/Macaulay2/packages/%/examples, $(EXAMPLE_SRC))

$(CURDIR)/M2/Macaulay2/packages/%/examples: $(CURDIR)/debian/examples/%
	mkdir -p $@
	cp -v $</*.out $@

execute_before_dh_auto_build: $(KATEX_FILES) $(EXAMPLE_DEST)
	touch M2/Macaulay2/packages/Style/prism.js

# since a "test" target exists, dh_auto_test defaults to using that, but
# it just prints the values of some variables.  we want the "check" target
# instead to run the test suite
# related: https://bugs.debian.org/924052
override_dh_auto_test-arch:
	$(MAKE) -C M2 check ArgumentMode="defaultMode - SetUlimit" \
		TLIMIT=unlimited

# create dumps of package documentation databases to ship with macaulay2-common
# and then load during postinst
PKGLIBDIR := debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/Macaulay2
PKGDOCDIR := debian/tmp/usr/share/doc/Macaulay2
DB_FILENAME := rawdocumentation-$(if \
	$(filter little, $(DEB_HOST_ARCH_ENDIAN)),dcba,abcd)-$(if \
	$(filter 64, $(DEB_HOST_ARCH_BITS)),8,4).db

DB_FILES = $(wildcard $(PKGLIBDIR)/*/cache/$(DB_FILENAME))
DUMP_FILES = $(DB_FILES:$(PKGLIBDIR)/%/cache/$(DB_FILENAME)=\
	$(PKGDOCDIR)/%/dump/rawdocumentation.dump)

$(PKGDOCDIR)/%/dump/rawdocumentation.dump: $(PKGLIBDIR)/%/cache/$(DB_FILENAME)
	mkdir -p $(dir $@)
# gdbm_load records the path of the database file and the timestamp in the
# dump file, so use a relative path and faketime for reproducibility
	cd $(dir $<) && \
		faketime '@$(SOURCE_DATE_EPOCH)' \
		gdbm_dump $(notdir $<) $(CURDIR)/$@

execute_after_dh_auto_install-indep: $(DUMP_FILES)
	rm -rf $(EXAMPLE_DEST)
	for DIR in $(subst /examples,,$(EXAMPLE_DEST)); \
	do if [ -z "$$(ls -A $$DIR)" ]; then rm -rf $$DIR; fi; \
	done
	rm -rf $(PKGLIBDIR) # remove package documentation database files
	$(MAKE) -C M2/Macaulay2/editors prism/prism.js
	cp M2/Macaulay2/editors/prism/prism.js \
		debian/tmp/usr/share/Macaulay2/Style

# https://github.com/Macaulay2/M2/issues/1144
execute_before_dh_link-indep:
	jdupes -rl debian/macaulay2-common/usr/share/doc/Macaulay2

override_dh_linktree-indep:
	dh_linktree -X.uuid

# example output, package test files, and database dumps must be plain text
override_dh_compress:
	dh_compress -Xexample-output -X.m2 -X.dump

execute_before_dh_elpa: debian/M2-pkg.el

debian/M2-pkg.el: debian/M2-pkg.el.in
	sed -e 's|@VERSION@|$(ELPA_VERSION)|g' $< > $@

# prevent dh_missing from failing when only building arch-dependent packages
execute_before_dh_missing:
	if [ ! -f debian/M2-pkg.el ]; \
	then \
		rm -rf debian/tmp/usr/share/emacs; \
	fi

override_dh_installdeb:
	dh_installdeb --define DEB_HOST_MULTIARCH=$(DEB_HOST_MULTIARCH) \
		--define DB_FILENAME=$(DB_FILENAME)

=== debian/tests/control ===
Test-Command: M2 --check 1
Depends: macaulay2
Restrictions: allow-stderr
Features: test-name=basic-tests

Test-Command: M2 --check 2
Depends: 4ti2, gfan, macaulay2, normaliz
Restrictions: allow-stderr
Features: test-name=core-tests

Test-Command: M2 --script debian/tests/check-packages.m2
Depends: 4ti2,
         cohomcalg,
         coinor-csdp,
         gfan,
         libmpfi-dev,
         macaulay2,
         msolve,
         nauty,
         normaliz,
         topcom
Restrictions: allow-stderr
Features: test-name=package-tests

Test-Command: M2 --script debian/tests/check-doc-db.m2
Depends: macaulay2
Features: test-name=database-smoke-test
